## woo 1.0+dfsg1

=== SConstruct ===
#!/usr/bin/scons
# coding: UTF-8
# vim:syntax=python:

#
# This is the master build file for scons (http://www.scons.org). It is experimental, though it build very well for me. Prequisities for running are having scons installed (debian & family: package scons)
#
# Type "scons -h" for woo-specific options and "scons -H" for scons' options. Note that Woo options will be remembered (saved in scons.config) so that you need to specify them only for the first time. Like this, for example:
#
#	scons -j2 brief=1 debug=0 optimize=1 flavor=1 exclude=extra,lattice,snow
#
# Next time, you can simply run "scons" or "scons -j4" (for 4-parallel builds) to rebuild targets that need it. IF YOU NEED TO READ CODE IN THIS FILE, SOMETHING IS BROKEN AND YOU SHOULD REALLY TELL ME.
#
# Scons will do preparatory steps (generating SConscript files from .pro files, creating local include directory and symlinking all headers from there, ...), compile files and install them.
#
# To clean the build, run `scons -c'. Please note that it will also _uninstall_ Woo from $PREFIX!
#
# TODO:
#  1. [REMOVED] [DONE] retrieve target list and append install targets dynamically;
#  2. [DONE] configuration and option handling.
#  3. Have build.log with commands and all output...
#
# And as usually, clean up the code, get rid of workarounds and hacks etc.
import os,os.path,string,re,sys,shutil
import SCons
# SCons version numbers are needed a few times
# rewritten for python2.4
ver=[str(x) for x in SCons.__version__.split('.')]
for i in range(0,len(ver)):
	def any2num(x):
		if x in ('0123456789'): return x
		else: return '0'
	ver[i]="".join([any2num(x) for x in ver[i]])
	if len(ver[i])>2: ver[i]=ver[i][0:2]+"."+ver[i][2:]
sconsVersion=10000*float(ver[0])
if len(ver)>1: sconsVersion+=100*float(ver[1])
if len(ver)>2: sconsVersion+=float(ver[2])
# print sconsVersion
#

##########################################################################################
############# OPTIONS ####################################################################
##########################################################################################

### hardy compatibility (may be removed at some later point probably)
### used only when building debian package, since at that point auto download of newer scons is disabled
if 'Variables' not in dir():
	Variables=Options
	BoolVariable,ListVariable,EnumVariable=BoolOption,ListOption,EnumOption

env=Environment(ENV=os.environ,tools=['default','textfile'])
flavorFile='scons.current-flavor'
env['sourceRoot']=os.getcwd()

flavorOpts=Variables(flavorFile)
flavorOpts.Add(('flavor','Config flavor to use (predefined: default or ""); append ! to use it but not save for next build (in scons.current-flavor)','default'))
flavorOpts.Update(env)
# multiple flavors - run them all at the same time
# take care not to save current flavor for those parallel builds
# if env['flavor']=='': env['flavor']='default'
# save the flavor only if the last char is not !
saveFlavor=True
if env['flavor'] and env['flavor'][-1]=='!': env['flavor'],saveFlavor=env['flavor'][:-1],False
if saveFlavor: flavorOpts.Save(flavorFile,env)

#if env['flavor']=='': env['flavor']='default'
optsFile='scons.flavor-'+(env['flavor'] if env['flavor'] else 'default')
if env['flavor']=='default': env['flavor']=''
flavor=env['flavor']
env['cxxFlavor']=('_'+re.sub('[^a-zA-Z0-9_]','_',env['flavor']) if env['flavor'] else '')
print '@@@ Using flavor',(flavor if flavor else '[none]'),'('+optsFile+') @@@'
if not os.path.exists(optsFile):
	print '@@@ Will create new flavor file',optsFile
	opts=Variables()
	opts.Save(optsFile,env)
else:
	opts=Variables(optsFile)
## compatibility hack again
if 'AddVariables' not in dir(opts): opts.AddVariables=opts.AddOptions

# save flavor file so that we know compilation flags
env['buildFlavor']=dict([(l.split('=',1)[0].strip(),eval(l.split('=',1)[1])) for l in file(flavorFile)])

env['buildCmdLine']=sys.argv

def colonSplit(x): return x.split(':')

#
# The convention now is, that
#  1. CAPITALIZED options are
#   (a) notorious shell variables (they correspons most the time to SCons environment options of the same name - like CPPPATH)
#   (b) c preprocessor macros available to the program source (like PREFIX and SUFFIX)
#  2. lowercase options influence the building process, compiler options and the like.
#

## detect virtual environment
## http://stackoverflow.com/a/1883251/761090
import sys,site
VENV=hasattr(sys,'real_prefix')
if not VENV and not hasattr(site,'getsitepackages'):
	# avoid this warning for rebuilds using -R, which should actually work just fine
	if saveFlavor:
		print 'WARN: it seems that you are running SCons inside a virtual environment, without having set it up properly (e.g. "source /my/virtual/env/bin/activate"). (sys.real_prefix is not defined, but site.getsitepackages is not defined either.) I will pretend we are inside a virtual environment, but things may break.'
	VENV=True

if VENV:
	defaultEXECDIR=sys.prefix+'/bin'
	pp=[p for p in sys.path if p.endswith('/site-packages')]
	defaultLIBDIR=pp[-1] if pp else None
	if not defaultLIBDIR: print 'WARN: no good default value of LIBDIR was found, you will have to specify one my hand'
else:
	defaultEXECDIR='/usr/local/bin'
	defaultLIBDIR=site.getsitepackages()[0]


opts.AddVariables(
	('LIBDIR','Install directory for python modules (the default is obtained via "import site; site.getsitepackages()[0]"; in virtual environments, where getsitepackages it not defined, it MUST be specified; in that case, also specify EXECDIR and use the virtual python interpreter to run SCons)',defaultLIBDIR),
	('EXECDIR','Install directory for executables; defaults to /usr/local/bin in normal environemtns and to $VIRTUAL_ENV/bin in virtual environments',defaultEXECDIR),
	BoolVariable('debug', 'Enable debugging information',0),
	BoolVariable('gprof','Enable profiling information for gprof',0),
	('optimize','Turn on optimizations; negative value sets optimization based on debugging: not optimize with debugging and vice versa. -3 (the default) selects -O3 for non-debug and no optimization flags for debug builds',-3,None,int),
	EnumVariable('PGO','Whether to "gen"erate or "use" Profile-Guided Optimization','',['','gen','use'],{'no':'','0':'','false':''},1),
	ListVariable('features','Optional features that are turned on','log4cxx,opengl,opencl,gts,openmp,vtk,qt4',names=['opengl','log4cxx','cgal','openmp','opencl','gts','vtk','gl2ps','qt4','cldem','sparc','noxml','voro','oldabi','nocapsule','never_use_this_one']),
	('jobs','Number of jobs to run at the same time (same as -j, but saved)',2,None,int),
	#('extraModules', 'Extra directories with their own SConscript files (must be in-tree) (whitespace separated)',None,None,Split),
	('cxxstd','Name of the c++ standard (or dialect) to compile with. With gcc, use gnu++11 (gcc >=4.7) or gnu++0x (with gcc 4.5, 4.6)','c++11'),
	('buildPrefix','Where to create build-[version][variant] directory for intermediary files','..'),
	('hotPlugins','Files (without the .cpp extension) that will be compiled separately even in the monolithic build (use for those that you modify frequently); comma-separated.',''),
	('chunkSize','Maximum files to compile in one translation unit when building plugins. (unlimited if <= 0, per-file linkage is used if 1)',7,None,int),
	('version','Woo version (if not specified, guess will be attempted)',None),
	('realVersion','Revision (usually bzr revision); guessed automatically unless specified',None),
	('CPPPATH', 'Additional paths for the C preprocessor (colon-separated)','/usr/include/vtk-5.8:/usr/include/eigen3:/usr/include/vtk'), # hardy has vtk-5.0
	('LIBPATH','Additional paths for the linker (colon-separated)',None),
	('libstdcxx','Specify libstdc++ location by hand (opened dynamically at startup), usually not needed',None),
	('QT4DIR','Directory where Qt4 is installed','/usr/share/qt4'),
	('PATH','Path (not imported automatically from the shell) (colon-separated)',None),
	('CXX','The c++ compiler','g++'),
	('CXXFLAGS','Additional compiler flags for compilation (like -march=core2).',None,None,Split),
	('LIBS','Additional libs to link to (like python2.6 for cygwin)',None,None,Split),
	('march','Architecture to use with -march=... when optimizing','native',None,None),
	('execCheck','Name of the main script that should be installed; if the current one differs, an error is raised (do not use directly, only intended for --rebuild',None),
	('defThreads','No longer used, specify -j each time Woo is run (defaults to 1 now)',-1),
	BoolVariable('lto','Use link-time optimization',0),
	#('SHLINK','Linker for shared objects','g++'),
	#('SHCCFLAGS','Additional compiler flags for linking (for plugins).',None,None,Split),
	('EXTRA_SHLINKFLAGS','Additional compiler flags for linking (for plugins).',None,None,Split),
	BoolVariable('QUAD_PRECISION','typedef Real as long double (=quad)',0),
	BoolVariable('brief',"Don't show commands being run, only what files are being compiled/linked/installed",True),
)
opts.Update(env)

if str(env['features'])=='all':
	print 'ERROR: using "features=all" is illegal, since it breaks feature detection at runtime (SCons limitation). Write out all features separated by commas instead. Sorry.'
	Exit(1)

if saveFlavor: opts.Save(optsFile,env)
# set optimization based on debug, if required 
if env['optimize']<0: env['optimize']=(None if env['debug'] else -env['optimize']) 

# handle colon-separated lists:
for k in ('CPPPATH','LIBPATH','QTDIR','PATH'):
	if env.has_key(k):
		env[k]=colonSplit(env[k])

# do not propagate PATH from outside, to ensure identical builds on different machines
#env.Append(ENV={'PATH':['/usr/local/bin','/bin','/usr/bin']})
# ccache needs $HOME to be set, also CCACHE_PREFIX if used; colorgcc needs $TERM; distcc wants DISTCC_HOSTS
# fakeroot needs FAKEROOTKEY and LD_PRELOAD
propagatedEnvVars=['HOME','TERM','DISTCC_HOSTS','LD_PRELOAD','FAKEROOTKEY','LD_LIBRARY_PATH','CCACHE_PREFIX']
for v in propagatedEnvVars:
	if os.environ.has_key(v): env.Append(ENV={v:os.environ[v]})
if env.has_key('PATH'): env.Append(ENV={'PATH':env['PATH']})

# get number of jobs from DEB_BUILD_OPTIONS if defined
# see http://www.de.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
if os.environ.has_key('DEB_BUILD_OPTIONS'):
	for opt in os.environ['DEB_BUILD_OPTIONS'].split():
		if opt.startswith('parallel='):
			j=opt.split('=')[1].split(',')[0] # there was a case of 5, in hardy...
			print "Setting number of jobs (using DEB_BUILD_OPTIONS) to `%s'"%j
			env['jobs']=int(j)



if sconsVersion>9700: opts.FormatOptionHelpText=lambda env,opt,help,default,actual,alias: "%10s: %5s [%s] (%s)\n"%(opt,actual,default,help)
else: opts.FormatOptionHelpText=lambda env,opt,help,default,actual: "%10s: %5s [%s] (%s)\n"%(opt,actual,default,help)
Help(opts.GenerateHelpText(env))

###########################################
################# BUILD DIRECTORY #########
###########################################
def getRealWooVersion():
	"Attempts to get woo version from RELEASE file if it exists or from bzr/svn, or from VERSION"
	import os.path,re,os
	if os.path.exists('RELEASE'):
		return file('RELEASE').readline().strip()
	baseVer='1.0'
	if os.path.exists('.git'):
		r0=os.popen("git rev-list HEAD --count 2>/dev/null").readlines()[0][:-1]
		r1=os.popen("git log -1 --format='%h'").readlines()[0][:-1]
		return baseVer+'.'+r0+'+git.'+r1
	if os.path.exists('.bzr'):
		r0=os.popen("LC_ALL=C bzr revno 2>/dev/null").readlines()[0][:-1]
		return baseVer+'.'+r0+'+bzr'
	if os.path.exists('VERSION'):
		return file('VERSION').readline().strip()
	return None

## ALL generated stuff should go here - therefore we must determine it very early!!
if not env.has_key('realVersion') or not env['realVersion']: env['realVersion']=getRealWooVersion() or 'unknown' # unknown if nothing returned
if not env.has_key('version'): env['version']=env['realVersion']

=== doc/Makefile ===
.PHONY: gen extras upload uploadpng default

gen:
	rm -rf sphinx2/build/html sphinx2/build/latex sphinx2/build/doctrees sphinx2/build-extra sphinx2/source-extra
	rm -f sphinx2/source/{woo,wooExtra,wooMain}.*.rst
	cd sphinx2/source; PYTHONPATH=. woo -x --fake-display  --quirks=0 -R gen.py
	cd sphinx2/build/latex; xelatex -interaction=batchmode Woo.tex; makeindex Woo; xelatex -interaction=nonstopmode Woo.tex; true
	# python -c 'import webbrowser; webbrowser.open("file://${PWD}/sphinx2/build/html/index.html")'
sphinxonly:
	cd sphinx2/source; PYTHONPATH=. woo -x --fake-display --quirks=0 gen.py
extras:
	rm -rf sphinx2/build-extra sphinx2/source-extra
	cd sphinx2/source; PYTHONPATH=. woo -x --fake-display -R gen.py --quirks=0 --only-extras
upload:
	rsync -r sphinx2/build/html/ woodem:woo-doc/
	rsync -r sphinx2/build/latex/Woo.pdf woodem:woo-doc/Woo.pdf
	for ex in sphinx2/build-extra/*; do rsync -r $$ex/html woodem:woo-private/`basename $$ex`/doc/; done
uploadpng:
	rsync -r sphinx2/build/html/ woodem:woo-doc-png/
	for ex in sphinx2/build-extra/*; do rsync -r $$ex/html woodem:woo-private/`basename $$ex`/doc-png/; done
default: gen upload

=== nsis/icons/Makefile ===
default:
	mpost woodem-6.mp
	# sudo apt-get install librsvg2-bin
	rsvg -w 256 -f png --keep-aspect-ratio woodem-6.woo.svg woo-icon.256.png
	rsvg -w 64 -f png --keep-aspect-ratio woodem-6.woo.svg woo-icon.64.png
	rsvg -w 256 -f png --keep-aspect-ratio woodem-6.woo-batch.svg woo-batch-icon.256.png
	# use 16-color palette for smaller size
	convert -flatten -colors 16 woo-icon.256.png woo-icon.256.ico
	convert -flatten -colors 16 -geometry 64x64\! woo-icon.64.png woo-icon.64.ico
	convert -flatten -colors 16 woo-batch-icon.256.png woo-batch-icon.256.ico
	cp woo-icon.64.ico ../../py/data/woo-favicon.ico
	cp woo-icon.64.ico ../../doc/sphinx2/source/_static/woo-favicon.ico
	cp woodem-6.woo.svg ../../gui/qt4/woo-logo.svg
	# make smaller rather than copy, so that SVG embedded in XHTML has the right size
	rsvg-convert woodem-6.woo.svg --width=120 --keep-aspect-ratio --format svg --output ../../py/data/woodem-6.woo.svg
	#cp woodem-6.woo.svg ../../py/data/woodem-6.woo.svg

=== doc/sphinx2/source/fig/Makefile ===
default:
		iperender -svg depot-brisbane.pdf depot-brisbane.svg

=== debian/changelog ===
woo (1.0+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Replace python-imaging by python-pil
    Closes: #866495
  * cme
  * debhelper 10
  * Drop unneeded "Testsuite: autopkgtest"

 -- Andreas Tille <tille@debian.org>  Sun, 07 Jan 2018 09:09:50 +0100

woo (1.0+dfsg1-1) unstable; urgency=medium

  * [ae1639e] Move to vtk6, add BD for python3.
  * [1e74080] Disable autotests temporarly. (Closes: #800407)
  * [6a9fe9e] Add MathJax_local.js to Files-Excluded.
  * [8ee1c9d] Imported Upstream version 1.0+dfsg1
  * [02150d7] Fix warnings in d/copyright.

 -- Anton Gladky <gladk@debian.org>  Tue, 27 Oct 2015 19:59:36 +0100

woo (1.0-3) unstable; urgency=medium

  * [ebc5dfc] Remove all march flags. (Closes: #797092)

 -- Anton Gladky <gladk@debian.org>  Sat, 05 Sep 2015 08:15:56 +0200

woo (1.0-2) unstable; urgency=medium

  * [013b8a2] Add VCS-fields in d/control.
  * [d571495] Remove non-existing python3-imaging from Depends.
  * [728c9f9] Remove unneded Conflicts from d/control.
  * [ac8c509] Remove core2 flag. (Closes: #797092)
  * [ebbda26] Ignore quilt dir
  * [9b2d614] Do not use gold-linker. (Closes: #797094)

 -- Anton Gladky <gladk@debian.org>  Fri, 04 Sep 2015 00:38:54 +0200

woo (1.0-1) unstable; urgency=medium

  * Initial packaging. (Closes: #794710)

 -- Anton Gladky <gladk@debian.org>  Thu, 06 Aug 2015 19:02:04 +0200

=== debian/control ===
Source: woo
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Václav Šmilauer <eu@doxos.eu>,
           Anton Gladky <gladk@debian.org>
Section: python
Priority: optional
Build-Depends: python-all,
               python-all-dev,
               python-setuptools,
               python3-setuptools,
               python3-all,
               python3-all-dev,
               debhelper (>= 10),
               libboost-all-dev,
               pyqt4-dev-tools,
               libqt4-dev,
               libqt4-dev-bin,
               qt4-dev-tools,
               libgle3-dev,
               libqglviewer-dev-qt4,
               libvtk6-dev,
               libgts-dev,
               libeigen3-dev,
               python3-minieigen,
               python-minieigen,
               freeglut3-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/woo.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/woo.git
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.4

Package: python-woo
Architecture: any
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python-xlrd,
         python-xlwt,
         python-numpy,
         python-matplotlib,
         python-colorama,
         python-qt4,
         python-xlib,
         python-genshi,
         python-psutil,
         python-minieigen,
         python3-minieigen,
         python-pil,
         python-h5py,
         python-lockfile,
         ipython,
         mencoder | libav-tools | ffmpeg,
         python-prettytable
Description: Discrete dynamic computations, esp. granular mechanics (python 2)
 Extesible and portable framework primarily for mechanics
 granular materials. Computation parts are written in c++ parallelized using
 OpenMP, fully accessible and modifiable from python (ipython console or
 scripts). Arbitrarily complex scene can be scripted. Qt-based user interface
 is provided, featuring flexible OpenGL display, inspection of all objects
 and runtime modification. Parametric preprocessors can be written in pure
 python, and batch system can be used to drive parametric studies. New
 material models and particle shapes can be added (in c++) without modifying
 existing classes.
 .
 Woo is an evolution of the Yade package
 (http://www.launchpad.net/yade), aiming at more flexibility, extensibility,
 tighter integration with python and user-friendliness.
 .
 This version is built with OpenMP enabled, and targets Python 2.x

Package: python3-woo
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         python3-xlrd,
         python3-xlsxwriter,
         python3-numpy,
         python3-matplotlib,
         python3-colorama,
         python3-pyqt4,
         python3-xlib,
         python3-genshi,
         python3-psutil,
         python3-minieigen,
         python3-pil,
         python3-h5py,
         python3-lockfile,
         ipython3,
         mencoder | libav-tools | ffmpeg,
         python3-prettytable
Description: Discrete dynamic compuations, esp. granular mechanics (python 3)
 Extesible and portable framework primarily for mechanics
 granular materials. Computation parts are written in c++ parallelized using
 OpenMP, fully accessible and modifiable from python (ipython console or
 scripts). Arbitrarily complex scene can be scripted. Qt-based user interface
 is provided, featuring flexible OpenGL display, inspection of all objects
 and runtime modification. Parametric preprocessors can be written in pure
 python, and batch system can be used to drive parametric studies. New
 material models and particle shapes can be added (in c++) without modifying
 existing classes.
 .
 Woo is an evolution of the Yade package
 (http://www.launchpad.net/yade), aiming at more flexibility, extensibility,
 tighter integration with python and user-friendliness.
 .
 This version is built with OpenMP enabled, and targets Python 3.x.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export PYBUILD_NAME=woo

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

override_dh_auto_clean:

override_dh_auto_test:

=== debian/tests/control ===
Tests: wootest
Depends: python-woo
